New file. Test for the bug in du that
authorJim Meyering <jim@meyering.net>
Wed, 14 May 2003 10:08:02 +0000 (10:08 +0000)
committerJim Meyering <jim@meyering.net>
Wed, 14 May 2003 10:08:02 +0000 (10:08 +0000)
was fixed by the 2003-05-12 change to lib/ftw.c.

tests/du/fd-leak [new file with mode: 0755]

diff --git a/tests/du/fd-leak b/tests/du/fd-leak
new file mode 100755 (executable)
index 0000000..2336ed8
--- /dev/null
@@ -0,0 +1,44 @@
+#!/bin/sh
+# check for file descriptor leak
+
+if test "$VERBOSE" = yes; then
+  set -x
+  du --version
+fi
+
+# Call this an expensive test.  It's not that expensive, but command line
+# limitations might induce failure on some losing systems.
+. $srcdir/../expensive
+
+pwd=`pwd`
+t0=`echo "$0"|sed 's,.*/,,'`.tmp; tmp=$t0/$$
+trap 'status=$?; cd $pwd; chmod -R u+rwx $t0; rm -rf $t0 && exit $status' 0
+trap '(exit $?); exit $?' 1 2 13 15
+
+framework_failure=0
+mkdir -p $tmp || framework_failure=1
+cd $tmp || framework_failure=1
+# Create 1296 (36^2) files.
+# Their names and separating spaces take up 3887 bytes.
+x='a b c d e f g h i j k l m n o p q r s t u v w x y z 0 1 2 3 4 5 6 7 8 9'
+f=
+for i in $x; do
+  for j in $x; do
+    f="$f $i$j"
+  done
+done
+
+# This may fail due to command line limitations.
+touch $f || framework_failure=1
+
+if test $framework_failure = 1; then
+  echo "$0: failure in testing framework" 1>&2
+  (exit 1); exit 1
+fi
+
+fail=0
+
+# With coreutils-5.0, this would fail due to a file descriptor leak.
+du $f > out || fail=1
+
+(exit $fail); exit $fail